var Package = require('dgeni').Package;
var path = require('path');

/**
 * @dgPackage website
 * @description Package builds web app with generated docs
 */
module.exports = new Package('website', [require('../navigation'), require('../search')])

// Add in the real processors for this package
.processor(require('./processors/website'))

// add more templates location
.config(function(templateFinder) {
  templateFinder.templateFolders.unshift(path.resolve(__dirname, 'templates'));
})

// add more tags
.config(function(parseTagsProcessor, getInjectables) {
  getInjectables(require('./tag-defs')).forEach(function(v) {
    parseTagsProcessor.tagDefinitions.push(v);
  });
})

// adding more templates to computePathsProcessor configuration
.config(function(computePathsProcessor) {
  computePathsProcessor.pathTemplates.push({
    docTypes: ['website'],
    pathTemplate: '${docType}/${name}',
    outputPathTemplate: '${id}'
  });
})
;